// ****************************************************************************
//
//          Aevol - An in silico experimental evolution platform
//
// ****************************************************************************
//
// Copyright: See the AUTHORS file provided with the package or <www.aevol.fr>
// Web: http://www.aevol.fr/
// E-mail: See <http://www.aevol.fr/contact/>
// Original Authors : Guillaume Beslon, Carole Knibbe, David Parsons
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#include "RnaList.h"

namespace aevol {

RnaList::~RnaList() {
  clear();
}

const std::list<Rna_7*>& RnaList::rnas() const {
  return rnas_;
}

void RnaList::rna_add(int32_t t_begin, int32_t t_end, Strand strand, double t_e, int32_t t_length, Promoter* prom) {
  rnas_.emplace_back(new Rna_7(t_begin, t_end, strand, t_e, t_length, prom));
}

void RnaList::clear() {
  for (auto& rna : rnas_) {
    delete rna;
  }
  rnas_.clear();
}

} // namespace aevol
